/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-19 at 05:31:48 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.doubleclicksearch.model;

/**
 * A saved column
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search Ads 360 API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SavedColumn extends com.google.api.client.json.GenericJson {

  /**
   * Identifies this as a SavedColumn resource. Value: the fixed string
   * doubleclicksearch#savedColumn.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The name of the saved column.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String savedColumnName;

  /**
   * The type of data this saved column will produce.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Identifies this as a SavedColumn resource. Value: the fixed string
   * doubleclicksearch#savedColumn.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this as a SavedColumn resource. Value: the fixed string
   * doubleclicksearch#savedColumn.
   * @param kind kind or {@code null} for none
   */
  public SavedColumn setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The name of the saved column.
   * @return value or {@code null} for none
   */
  public java.lang.String getSavedColumnName() {
    return savedColumnName;
  }

  /**
   * The name of the saved column.
   * @param savedColumnName savedColumnName or {@code null} for none
   */
  public SavedColumn setSavedColumnName(java.lang.String savedColumnName) {
    this.savedColumnName = savedColumnName;
    return this;
  }

  /**
   * The type of data this saved column will produce.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The type of data this saved column will produce.
   * @param type type or {@code null} for none
   */
  public SavedColumn setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public SavedColumn set(String fieldName, Object value) {
    return (SavedColumn) super.set(fieldName, value);
  }

  @Override
  public SavedColumn clone() {
    return (SavedColumn) super.clone();
  }

}
