/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-19 at 05:31:48 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.doubleclicksearch.model;

/**
 * The request to update availability.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search Ads 360 API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UpdateAvailabilityRequest extends com.google.api.client.json.GenericJson {

  /**
   * The availabilities being requested.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Availability> availabilities;

  static {
    // hack to force ProGuard to consider Availability used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(Availability.class);
  }

  /**
   * The availabilities being requested.
   * @return value or {@code null} for none
   */
  public java.util.List<Availability> getAvailabilities() {
    return availabilities;
  }

  /**
   * The availabilities being requested.
   * @param availabilities availabilities or {@code null} for none
   */
  public UpdateAvailabilityRequest setAvailabilities(java.util.List<Availability> availabilities) {
    this.availabilities = availabilities;
    return this;
  }

  @Override
  public UpdateAvailabilityRequest set(String fieldName, Object value) {
    return (UpdateAvailabilityRequest) super.set(fieldName, value);
  }

  @Override
  public UpdateAvailabilityRequest clone() {
    return (UpdateAvailabilityRequest) super.clone();
  }

}
